;NO SLEEP! - 256b intro to Function 2018
; code - TomCat
; music - ern0

;Inspirations:
; Insomnia by Faceless

;the pattern is 128 notes long
;stored only 32 notes for channel1
;after that the data is modofied
;channel2 is full hardcoded.

M EQU 59

F_4 = (10500000000/88/36999+M/2)/M
E4 = (10500000000/88/32963+M/2)/M
D4 = (10500000000/88/29366+M/2)/M
C_4 = (10500000000/88/27718+M/2)/M
B3 = (10500000000/88/24694+M/2)/M
A3 = (10500000000/88/22000+M/2)/M
B2 = (10500000000/88/12347+M/2)/M
F_2 = (10500000000/88/9650+M/2)/M
F2 = (10500000000/88/9250+M/2)/M

ORG 256
 MOV    DS,AX
 MOV    [46CH],AX       ; reset timer counter
;---------------------------------------------------------------------
main:
 MOV    AL,[46CH]       ; get BIOS timer counter
 SHR    AL,1            ; gap or note?
 CBW                    ; put zero in AH
 PUSHF
 AND    AL,31
 XCHG   BP,AX           ; get channel1 data
 MOV    AL,[BP+SI-256+table]
 POPF
 JC     @F              ; we need gap between the notes
 CMP    AL,1            ; IF channel1 is pause OR deep note
 JL     skip            ; THEN skip channel2
 MOV    AL,B3           ; channel2 note is B3
 CMP    BYTE [46CH],110*2
 JB     @F              ; until the 110th note
 MOV    AL,A3           ; then A3
@@:
 JO     skip            ; at the second half of the song
 CMP    AL,F_4          ; F_4 should swap to D4
 JNE    skip
 MOV    AL,D4
skip:
 MOV    AH,M            ; counter = data * Multiplier
 MUL    AH
beep:
 OUT    42H,AL          ; lowbyte of the counter
 MOV    AL,AH
 OUT    42H,AL          ; highbyte of the counter
 SALC                   ; if pause then speaker turn off
 OUT    61H,AL          ; else turn on
;---------------------------------------------------------------------
 CBW                    ; if speaker off then AH=0
 IN     AL,60H          ; if ESC pressed then AL=1
 DEC    AX              ; if AX=1 then EXIT
 JNZ    main
RETN                    ; exit to DOS
;---------------------------------------------------------------------
table:                  ; channel1 data, 0 -> pause
DB 0,B2,E4,0,E4,0,0,F_4,0,B2,F_4,0,F_4,0,0,C_4
DB 0,F2,C_4,0,C_4,0,0,D4,0,F_2,D4,0,C_4,0,D4,0
